/// <reference path="../lib/SpreadJS/definition/gcspread.sheets.d.ts"/>
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ColorPickerCellType = (function (_super) {
    __extends(ColorPickerCellType, _super);
    function ColorPickerCellType() {
        _super.apply(this, arguments);
    }
    ColorPickerCellType.prototype.createEditorElement = function (context) {
        //Create input presenter.
        return document.createElement("input");
    };
    ColorPickerCellType.prototype.activateEditor = function (editorContext, cellStyle, cellRect, context) {
        var $editor = $(editorContext);
        _super.prototype.activateEditor.call(this, editorContext, cellStyle, cellRect, context);
        $editor.css("position", "absolute");
        $editor.colorpicker();
        $editor.attr("gcUIElement", "gcEditingInput");
        $(".colorpicker").attr("gcUIElement", "gcEditingInput");
    };
    ColorPickerCellType.prototype.deactivateEditor = function (editorContext, context) {
        if (editorContext) {
            var $editor = $(editorContext);
            $editor.colorpicker("hide");
            $editor.colorpicker("destroy");
        }
        _super.prototype.deactivateEditor.call(this, editorContext, context);
    };
    ColorPickerCellType.prototype.setEditorValue = function (editorContext, value, context) {
        $(editorContext).colorpicker("setValue", value);
    };
    ColorPickerCellType.prototype.getEditorValue = function (editorContext, context) {
        return $(editorContext).colorpicker("getValue");
    };
    ColorPickerCellType.prototype.updateEditor = function (editorContext, cellStyle, cellRect, context) {
        if (editorContext) {
            var $editor = $(editorContext);
            $editor.css("width", cellRect.width);
            $editor.css("height", cellRect.height);
        }
    };
    ColorPickerCellType.prototype.paint = function (ctx, value, x, y, width, height, style, context) {
        if (value) {
            ctx.fillStyle = value;
            ctx.fillRect(x, y, width, height);
            ctx.fillStyle = "#FFFFFF";
            _super.prototype.paint.call(this, ctx, value, x, y, width, height, style, context);
        }
        else {
            _super.prototype.paint.call(this, ctx, value, x, y, width, height, style, context);
        }
    };
    return ColorPickerCellType;
}(GcSpread.Sheets.CustomCellType));
//# sourceMappingURL=ColorPickerCellType.js.map